#!/usr/bin/perl
# SysWatch v1.2 [19990628] by Chris Martino <chris@weirdo.net>
# You can download the latest version of this script as well as 
# other scripts at http://www.weirdo.net/scripts/

### Configuration Area ###

# Memory/Swap info.  You must plug these in manually if you are
# using something other than Linux, FreeBSD or SunOS.
$memory = "";		# How much memory, in megabytes.
$swap = "";		# How much swap, in megabytes.


# List of devices that you don't want to see (We automagically exclue NFS devices)
$exclude_nfs = "TRUE";
@exclude_devs = ( "/proc", "fd", "swap", "procfs" );
          
# URL to the greendot.gif and reddot.gif image.
$image = 'greendot.gif';
$full_image = 'reddot.gif';

# [1/0] What information do you want the CGI to display?
# 1 = show info ; 0 = don't show info.
$showdrivemap = 1; 	# Do you want to show the drivemaps?
$showwhat = 1;		# Do you want to show what people are doing?
$showhogs = 1;		# Do you want to show what is taking up
			# alot of resources?

### End Configuration ###

##### Do NOT edit below here unless you know what you're doing!!  #####
# ------------------------------------------------------------------- #

$temp_command;
@devinfo;
@df_info;
$info;
@show_list;
$dev_count= 0;
$devline;
$bad_line= "";

$sysname = `hostname`;
$sysos = `uname -sr`;
$uptime = `uptime`;
$tmptop = '/tmp/tmptop';
$tmpw = '/tmp/tmpw';

if ( $sysos =~ /freebsd/i ) {
        $memory = `expr \`sysctl -a | grep hw.physmem | cut -c13-21\` \/ 1048567`;
        $swap = `top |grep -i swap | cut -c7-9`;
        chomp($swap);
        chomp($memory);
} elsif ( $sysos =~ /linux/i ) {
	$memory = `free -m |grep -i mem | cut -c16-18`;
	$swap = `free -m |grep -i swap |cut -c16-18`;
        chomp($swap);
        chomp($memory);
} elsif (sysos =~ /sunos/i ) {
	$memgather = `top | grep Mem`;
	if ( $memgather =~ /^Memory\: (\d+)M real.*(\d+)M swap in use, (\d+)M swap/ ) {
		$memory = $1;
		$swap = $2 + $3;
	} else {
		$memory = $memory;
		$swap = $swap;
	}
} else {
	$memory = $memory;
	$swap = $swap;
};

$temp_command= build_command( $remote_host, $remote_user, "df -k" );
@devinfo = `$temp_command`;

foreach $devline ( @devinfo ) {
  
  chomp( $devline );
  
  if( $bad_line ne "" ) {
    $df_info[0]= $bad_line;
    ($df_info[1], $df_info[2], $df_info[3], $df_info[4], $df_info[5] )
      = split( ' ', $devline);   
    $bad_line = "";   
  } else {
    @df_info = split( ' ', $devline);
  }
    
  if( $df_info[1] ne "" ) {
    $bad_line = "";
  } else {
    # Okay we proably have a long line for the devices so df has wraped the line ARG.
    $bad_line= $df_info[0]; # save this for next pass
  };
    
  if ((not (( $df_info[0] =~ /^Filesystem/ ) ||
      ( in( $df_info[0], @exclude_devs ) ))) &&
      ( $bad_line eq "")) {
  
    if( not(( $exclude_nfs eq "TRUE" ) && ( $df_info[0] =~ /^.*:.*$/ )) ) {

      $show_list[ $dev_count++]=[ @df_info ];
    };
  }
}

chomp($uptime);
chomp($sysname);
chomp($sysos);
chomp($cuthome);

if ( $sysos =~ /linux/i ) {
	open(OUTF,">>$tmptop");
        	print OUTF `ps aux |grep -A7 PID`;
	close(OUTF);
} else {
	open(OUTF,">>$tmptop");
		print OUTF `top -o cpu -d1 10 |grep -A7 PID`;
	close(OUTF);
};
open(OUTF,">>$tmpw");
	print OUTF `w`;
close(OUTF);
print "Content-type: text/html\n\n";

print <<EndHTML;
<html>
<head>
<title>$sysname system information</title>
</head>
<body bgcolor=#000000 text="#ffffff">
<font face="courier, courier new, fixed, arial, helvetica" size="2">
<br>
<p>
<center>
<table cellpadding="0" cellspacing="0" width="522" border="0">
</table>
<table bgcolor=#000000 width=522 border=0 cellpadding=2 cellspacing=0>
<tr>
<td width="522" height="23" bgcolor=#231d53 colspan=1>
<font color=#ffffff  face="arial, helvetica" size="2">
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;System Information
</font>
</td>   
</tr>
<tr><td><font face="arial, helvetica" size="2"><pre>
SysInfo    : $sysname
&nbsp;   $uptime

OS	  : $sysos
RAM	: $memory MB (approx.)
Swap	: $swap MB (approx.)
</pre></font></td></tr>
</table>
EndHTML
;


if ( $showdrivemap == 1 ) {
	print "<table width=522 bgcolor=#000000 border=0 cellpadding=2 cellspacing=0>\n";
	print "<tr>\n";
	print "<td height=\"23\" bgcolor=#231d53 colspan=6>\n";
	print "<font color=#ffffff  face=\"arial, helvetica\" size=\"2\">\n";
	print "&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Drive map\n";
	print "</font>\n";
	print "</td>\n";   
	print "</tr>\n";
	print "<tr>\n";
	print "<td align=center><font face=\"arial, helvetica\" size=\"2\"><b>Filesystem</b></font></td>\n";
	print "<td align=center><font face=\"arial, helvetica\" size=\"2\"><b>Mount</b></font></td>\n";
	print "<td align=center><font face=\"arial, helvetica\" size=\"2\"><b>Use</b></font></td>\n";
	print "<td align=center><font face=\"arial, helvetica\" size=\"2\"><b>Used</b></font></td>\n";
	print "<td align=center><font face=\"arial, helvetica\" size=\"2\"><b>Avail</b></font></td>\n";
	print "<td align=center><font face=\"arial, helvetica\" size=\"2\"><b>Size</b></font></td>\n";
	if ( $dev_count > 0 ) {
	  foreach $item ( @show_list ) {
	    $disk_full= 0; # Used to graph the amount of disk space full
	    print "<tr>\n";
	    print "<td align=left><font face=\"arial, helvetica\" size=\"2\">@{$item}[0]</font></td>\n";
	    print "<td align=left><font face=\"arial, helvetica\" size=\"2\">@{$item}[5]</font></td>\n";
	    print "<td align=left><font face=\"arial, helvetica\" size=\"2\">\n";
	    $disk_full= @{$item}[4];
	    chop( $disk_full);
	    if( $disk_full < 90 ) {
	      if( $disk_full == 0 ) {
	        print "@{$item}[4]</font></td>\n";
	      } else {
	      print "<img src=\"$image\" height=10 width=$disk_full> @{$item}[4]</font></td>\n";
	      };
	    } else {
	        print "<img src=\"$full_image\" height=10 width=$disk_full> @{$item}[4]</font></td>\n";
	    };
	    print "<td align=right><font face=\"arial, helvetica\" size=\"2\">@{$item}[2]\K</font></td>\n";
	    print "<td align=right><font face=\"arial, helvetica\" size=\"2\">@{$item}[3]\K</font></td>\n";
	    print "<td align=right><font face=\"arial, helvetica\" size=\"2\">@{$item}[1]\K</font></td>\n";
	    print "</tr>\n";
	  }
	} else {
	   print "<tr>\n";
	   print "<td align=center colspan=6><font face=\"arial, helvetica\" size=\"2\">No Disk info avaible</font></td>\n";
	   print "</tr>\n";
	 }
	print "</table></p>";
}

if ( $showwhat == 1 ) {
	print "<p>\n";
	print "<table bgcolor=#000000 width=522 border=0 cellpadding=2 cellspacing=0>\n";
	print "<tr>\n";
	print "<td width=\"522\" height=\"23\" bgcolor=#231d53 colspan=1>\n";
	print "<font color=#ffffff  face=\"arial, helvetica\" size=\"2\">\n";
	print "&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Who's doing What\n";
	print "</font>\n";
	print "</td>\n";
	print "</tr>\n";
	print "<tr><td><font face=\"arial, helvetica\" size=\"2\"><pre>\n";
	open(INF, "$tmpw");
		@w = <INF>;
	close(INF);
	print "\n@w";
	print "</pre></font></td></tr></table>";
}

if ( $showhogs == 1 ) {
	print "<table bgcolor=#000000 width=522 border=0 cellpadding=2 cellspacing=0>\n";
	print "<tr>\n";
	print "<td width=\"522\" height=\"23\" bgcolor=#231d53 colspan=1>\n";
	print "<font color=#ffffff  face=\"arial, helvetica\" size=\"2\">\n";
	print "&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Resource Hogs\n";
	print "</font>\n";
	print "</td>\n";
	print "</tr>\n";
	print "<tr><td><font face=\"arial, helvetica\" size=\"2\"><pre>\n";
	open(INF, "$tmptop");
		@top = <INF>;
	close(INF);
	print "\n@top\n";
	print "</pre></font></td></tr></table></p>";
}
print "<hr><font face=\"arial\" size=1>Output produced by <a href=\"http://www.weirdo.net/scripts/\">SysWatch v1.2</a></font>\n";
print "</body></html>\n";
`rm $tmptop`;
`rm $tmpw`;

sub build_command {

  $remote_host= shift;
  $remote_login= shift;
  $command= shift;
  $ret_command="bad thing";

  if ( $remote_host ne "" ) {
    if( $remote_login ne "" ) {
      $ret_command = sprintf( "rsh %s -l %s %s", $remote_host, $remote_login, $command);
    } else {
      $ret_command = sprintf( "rsh %s %s", $remote_host, $command);
    }
  } else {
    $ret_command= $command;
  };

  print( "Command: $ret_command\n");
  return $ret_command;

};

sub in { 

    $this= shift;
    @here=@_; 
    $num;
    $found_it=0;

#    printf( "this:%s here:%d\n", $this, scalar( @here));

    for( $num=0; (($num < scalar( @here)) && ( ! $found_it )); $num++) {
#       printf( "here[ %d]: %s, this: %s\n",  $num, $here[ $num], $this);
        if( $here[ $num] eq $this ) {
            $found_it=1;
        };
    };
    return $found_it;
};
